std::list::append_range(3)

NAME
std::list::append_range - std::list::append_range

Synopsis
   template< container-compatible-range<T> R > (since C++23)
   void append_range( R&& rg );
   Inserts copies of elements from the range rg before end(), in non-reversing order.
   No iterators or references are invalidated.
   Each iterator in rg is dereferenced exactly once.

Parameters
   rg - a container compatible range, that is, an input_range whose elements are
           convertible to T

Type requirements
   -
   T must be EmplaceConstructible into list from *ranges::begin(rg). Otherwise, the
   behavior is undefined.

Return value
   (none)

Complexity
   Linear in size of rg. The number of calls to the constructor of T is exactly equal
   to the std::ranges::size(rg)).

Exceptions
   If an exception is thrown for any reason, this function has no effect (strong
   exception safety guarantee).

Notes
       Feature-test macro Value Std Feature
   __cpp_lib_containers_ranges 202202L (C++23) Ranges-aware construction and insertion

Example
// Run this code
 #include <algorithm>
 #include <cassert>
 #include <list>
 #include <vector>
 int main()
 {
     auto head = std::list{1, 2, 3, 4};
     const auto tail = std::vector{-5, -6, -7};
 #ifdef __cpp_lib_containers_ranges
     head.append_range(tail);
 #else
     head.insert(head.end(), tail.cbegin(), tail.cend());
 #endif
     assert(std::ranges::equal(head, std::list{1, 2, 3, 4, -5, -6, -7}));
 }

See also
   prepend_range adds a range of elements to the beginning
   (C++23) (public member function)
   insert_range inserts a range of elements
   (C++23) (public member function)
   push_back adds an element to the end
                 (public member function)
   emplace_back constructs an element in-place at the end
   (C++11) (public member function)